//+------------------------------------------------------------------+
//|                                                  rsi extreme.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright "GGG Mcon France"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 YellowGreen // Lime
#property indicator_color4 Violet//Red
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2

extern int rsiperiod = 21;
extern int rsiperiod2 = 8;
extern int rsiperiod3 = 4;

double buy[];
double sell[];
double buy_trend[];
double sell_trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   IndicatorShortName("rsi extreme");
 
   SetIndexBuffer(0,buy);
   SetIndexStyle(0,DRAW_ARROW,0,4);
   SetIndexArrow(0,159);
   SetIndexLabel(0,"buy");
   SetIndexEmptyValue(0,0.0);
   SetIndexDrawBegin(0,200);
  
   SetIndexBuffer(1,sell);
   SetIndexStyle(1,DRAW_ARROW,0,4);
   SetIndexArrow(1,159);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(1,"sell");
       SetIndexDrawBegin(1,200);

   SetIndexBuffer(2,buy_trend);
   SetIndexStyle(2,DRAW_LINE,0,4);
   SetIndexLabel(2,"buy");
   SetIndexEmptyValue(2,0.0);
    SetIndexDrawBegin(2,200);

   SetIndexBuffer(3,sell_trend);
   SetIndexStyle(3,DRAW_LINE,0,4);
   SetIndexEmptyValue(3,0.0);
   SetIndexLabel(3,"sell");
       SetIndexDrawBegin(3,200);

   
   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
  {
 //  ObjectsDeleteAll(0,OBJ_ARROW);
   return(0);
  }
//+------------------------------------------------------------------+
int start()
  {
    static bool trend_buy; static bool trend_sell;
    static bool arrow_buy = false; static bool  arrow_sell = false; 
    //static datetime  bar;
   int  x = -1;
   int  cb = IndicatorCounted();
   if( cb<0 ) return(-1);
   if( cb > 0 )  cb--;
    x = Bars - cb;
//---- macd counted in the 1-st additional buffer
   for(int i=x; i>=0; i--)   
    {
    double r1a = iRSI(NULL,0,rsiperiod,PRICE_WEIGHTED,i);
    double r1b = iRSI(NULL,0,rsiperiod,PRICE_WEIGHTED,i+1);
    double r2a = iRSI(NULL,0,rsiperiod2,PRICE_WEIGHTED,i);
    double r2b = iRSI(NULL,0,rsiperiod2,PRICE_WEIGHTED,i+1);
    double r3a = iRSI(NULL,0,rsiperiod3,PRICE_WEIGHTED,i);
    double r3b = iRSI(NULL,0,rsiperiod3,PRICE_WEIGHTED,i+1);
   
 //============================================================================
    if(trend_buy == false && arrow_buy == false &&  r1a>50 && r2a>50 && r3a>50)
    
     { trend_buy = true; trend_sell = false; arrow_buy = true;  } 
    else                                     arrow_buy = false;
   
    if( trend_sell == false && arrow_sell == false && r1a<50  && r2a<50 && r3a<50 )  
    { trend_sell = true;  trend_buy = false; arrow_sell = true; }
      else                                   arrow_sell = false;

 //=================== ARROW ============================================  
  
    if(  arrow_buy == true )  buy[i] =  Close[i]-5*Point; 
    else                      buy[i] = 0.0;
  
    if( arrow_sell == true )   sell[i] = Close[i]+5*Point;
    else                       sell[i] = 0.0;        
  
  //=================== TREND ===========================================
   
    static bool up =0; static bool down = 0;
    if( r1a>50 && r2a>50 && r3a>50 )  { up = 1; down = 0;}
    if( r1a<50 && r2a<50 && r3a<50 )  { up = 0; down = 1;}
  
    if( up == true ) { buy_trend[i] = iMA(NULL,0,5,0,2,4,i);     }    
    else               buy_trend[i] = 0.0;     
  
     if( down == true ) { sell_trend[i] = iMA(NULL,0,5,0,2,4,i);   }
    else                  sell_trend[i] = 0.0;     
   
  // i--;
   }
   return(0);
  }
//+------------------------------------------------------------------+
